<?php

declare(strict_types=1);

namespace Intergo\LaravelAuthMiddleware\Http\Middleware\Api;

use Intergo\BaseClient\Responses\BaseResponseInterface;
use Intergo\LaravelAuthMiddleware\Services\Microservices\AuthService;

class AuthenticateServiceWeb extends AuthenticateApi
{
    /**
     * This is used for authenticating Web tokens on services that don't have a session.
     * Usually api only services that have Manager routes.
     *
     * @param string $token
     * @param string $ip
     * @return BaseResponseInterface
     */
    protected function authenticate(string $token, string $ip)
    {
        return (new AuthService())
            ->setCredentials(config('auth-middleware.web_site'), config('auth-middleware.web_site_secret'))
            ->authenticateServiceWeb($token, $ip);
    }
}

