<?php

namespace Intergo\LaravelAuthMiddleware\Http\Middleware\Api;

use Closure;
use Exception;
use Illuminate\Support\Facades\Auth;
use Intergo\LaravelAuthMiddleware\Models\AuthUser;
use Intergo\LaravelAuthMiddleware\Traits\ResponseTrait;

class CheckPermissionApi
{
    use ResponseTrait;

    /**
     * Handle the incoming request.
     *
     * @param $request
     * @param Closure $next
     * @param string $params
     * @return mixed
     * @throws Exception
     */
    public function handle($request, Closure $next, string $params = '')
    {
        $permissions = array_unique(array_filter(array_map('trim', explode('|', $params))));
        /** @var AuthUser $user */
        $user = Auth::user();
        foreach ($permissions as $permission) {
            if ($user->hasPermission($permission)) {
                return $next($request);
            }
        }
        return $this->failed("Access Denied. You do not have permission to {$params}.");
    }
}
